from __future__ import annotations

from typing import Dict, List


class WorkflowRequestFileIF:
    filename: str
    content: bytes


class WorkflowTemplateIF:
    filename: str
    content: bytes


class WorkflowIF:
    workflow_name: str
    templates: List[WorkflowTemplateIF]
    requests: List[WorkflowRequestIF]

    def render_templates(self, argument: Dict) -> List[WorkflowRequestFileIF]:
        pass


class WorkflowRequestIF:
    workflow_request_id: int
    workflow: WorkflowIF
    workflow_name: str
    argument: str  # JSON-formatted
    files: List[WorkflowRequestFileIF]
    job_id: str
